/*
** const.c
**
** Part of RPN calculator
** Copyright (c) 2007, 2010 NuukiaWorld
**
**  RPN calculator is free software; you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* includes nokix headers */
#include <nokix/all.h>

#include "main.h"
#include "stack.h"

/*******************************************************/

/*******************************************************/

/*******************************************************/

void const_init(void) {

	struct menu_item item = {
		NULL, NULL, NULL, 0, 0, OMSG_CONST, action_ok_back, MIF_FINISH_SHORTCUT
	};
	const const_data_t *data;

	// Delete old items (if any)
	while (menu_get_item (1, 1)) menu_rem_item(1, 1);

	data = (const_data_t*)msg_argv[0];

	// Add new items
	do {
		item.title = (nokstr_t*)data->name[const_mode];
		item.arg = (unsigned int)data;
		menu_add_item (1, 0, &item);
	} while( (++data)->name[0] != NULL );
}

/* Changes between constant names (name[0]) and symbol+unit (name[1]) in the constants menu
*/
void const_switch(void) {

	unsigned int c;
   struct menu_item *item;

   const_mode ^= 1;
   for( c = 1; ( item = menu_get_item( 1, c ) ); c++ ) {
      item->title = (nokstr_t*)( (const const_data_t*)item->arg )->name[const_mode];
   }
   send_message(MSG_REDRAW_MENU);
}

void const_calc(void) {

	if( !stack_dup(1) ) return;
   stack->stack[0] = ( (const const_data_t*)msg_argv[0] )->value;
}

